//################################
//## PALMOS                     ##
//################################

#include "PalmOS.h"
SndStreamRef main_stream = 0;
MemHandle ARM_code_handler;
char* ARM_code;

int palmos_sound_output_callback( 
    void* user_data,
    int stream,
    void* buffer,
    int frames )
{
    sound_struct* ss = (sound_struct*)user_data;
    ss->out_buffer = buffer;
    ss->out_frames = frames;
    ss->out_time = 0;
    main_sound_output_callback( ss, 0 );
    return 0;
}

int device_sound_stream_init( void )
{
    main_stream = 0;
    
    if( !( g_snd.mode & SOUND_MODE_INT16 ) )
    {
	dprint( "Invalid sound mode\n" );
	return 1;
    }

    UInt32 processor; //Processor type
    ARM_code = (char*)palmos_sound_output_callback;
    FtrGet( sysFileCSystem, sysFtrNumProcessorID, &processor );
    if( sysFtrNumProcessorIsARM( processor ) )
    {
	SndStreamCreate( 
	    &main_stream,
    	    sndOutput,
	    g_snd.freq,
	    sndInt16Little,
	    sndStereo,
	    (SndStreamBufferCallback) ARM_code,
	    &g_snd,
	    4096,
	    1 );
	SndStreamStart( main_stream );
    }
    else 
    {
	main_stream = 0;
    }
    g_snd.channels = 2;
    
    g_snd.latency = 1024;

    return 0;
}

void device_sound_stream_input( bool enable )
{
}

const UTF8_CHAR* device_sound_stream_get_driver_info( void )
{
    return "SndStream";
}

const UTF8_CHAR* device_sound_stream_get_driver_name( void )
{
    return "sndstream";
}

int device_sound_stream_get_drivers( UTF8_CHAR*** names, UTF8_CHAR*** infos )
{
    return 0;
}

int device_sound_stream_get_devices( const UTF8_CHAR* driver, UTF8_CHAR*** names, UTF8_CHAR*** infos, bool input )
{
    return 0;
}

void device_sound_stream_close( void )
{
    if( main_stream )
    {
	SndStreamDelete( main_stream );
	main_stream = 0;
    }
}
