#pragma once

#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#ifdef AUDIOBUS_URL
#import "Audiobus.h"
#endif

#define MAX_TOUCHES 10

extern CGDataProviderRef g_fb_provider;
extern CGColorSpaceRef g_fb_colorspace;
extern CGImageRef g_fb_image;
extern CGRect g_fb_rect;

extern volatile bool g_eventloop_stop_request;
extern volatile bool g_eventloop_stop_answer;

@interface MyView : UIView 
{
    // The pixel dimensions of the backbuffer
    GLint backingWidth;
    GLint backingHeight;
    
    EAGLContext* context;
    
    // OpenGL names for the renderbuffer and framebuffers used to render to this view
    GLuint viewRenderbuffer, viewFramebuffer, depthRenderbuffer;
    
    // Touches
    UITouch* m_touches[ MAX_TOUCHES ];
    int touches_num;
    
#ifdef AUDIOBUS_URL
    ABAudiobusController* audiobusController;
#endif
}

- (void)orientationChanged: (NSNotification*)aNotification;
- (int)viewInit;
- (void)redrawAll;
- (void)audiobusInit;
- (void)audiobusDeinit;

@end

void sundog_init( MyView *view );
void sundog_deinit( void );
