package nightradio.pixilang;

import android.util.Log;

import java.io.File; 
import java.io.FileOutputStream; 
import java.io.BufferedInputStream;
import java.util.zip.ZipEntry; 
import java.util.zip.ZipInputStream;

public class Decompress 
{ 
	private BufferedInputStream _zipInputStream; 
	private String _location; 
	 
	public Decompress( BufferedInputStream zipInputStream, String location ) 
	{ 
		_zipInputStream = zipInputStream; 
	    _location = location; 
	 
	    _dirChecker( "" ); 
	} 
	 
	public void unzip() 
	{ 
		try { 
			BufferedInputStream fin = _zipInputStream; 
			ZipInputStream zin = new ZipInputStream( fin ); 
			ZipEntry ze = null; 
			while( ( ze = zin.getNextEntry() ) != null ) 
			{ 
				Log.v( "Decompress", "Unzipping " + ze.getName() ); 
	 
				if( ze.isDirectory() ) 
				{ 
					_dirChecker( ze.getName() ); 
				} 
				else 
				{
					FileOutputStream fout = new FileOutputStream( _location + ze.getName() );
					byte[] buffer = new byte[ 4096 ];
					int length;
					while( ( length = zin.read( buffer ) ) > 0 ) 
					{
						fout.write( buffer, 0, length );
					}					
					zin.closeEntry(); 
					fout.close();
				}
			} 
			zin.close(); 
	    } catch( Exception e ) { 
	    	Log.e( "Decompress", "unzip", e ); 
	    }
	} 
	 
	private void _dirChecker( String dir ) 
	{ 
	    File f = new File( _location + dir ); 
	 
	    if( !f.isDirectory() ) 
	    { 
	    	f.mkdirs(); 
	    } 
	} 
}
